unit untPrgOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Grids, FileCtrl, Buttons, Menus;

type 
  TRange = record
             B,  C: Integer;
            end;
type
  TfrmPrgOpt = class(TForm)
    grpbxLoad: TGroupBox;
    ckbxRunScrMsg: TCheckBox;
    ckbxRunLastFile: TCheckBox;
    bvlLoad: TBevel;
    lblRunScrMsg: TLabel;
    lstbxMsgPaths: TListBox;
    grpbxMisc: TGroupBox;
    lblAddNumComm1: TLabel;
    cmbxAddNumComm: TComboBox;
    ckbxAddNumComm: TCheckBox;
    ckbxCod1C: TCheckBox;
    bvlMisc: TBevel;
    pmnMsgPaths: TPopupMenu;
    itmAddPath: TMenuItem;
    itmPasteStrings: TMenuItem;
    N1: TMenuItem;
    itmMovePath: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure cmbxAddNumCommKeyPress(Sender: TObject; var Key: Char);
    procedure ckbxRunScrMsgClick(Sender: TObject);
    procedure cmbxAddNumCommChange(Sender: TObject);
    procedure ckbxAddNumCommClick(Sender: TObject);
    procedure pmnMsgPathsPopup(Sender: TObject);
    procedure itmAddPathClick(Sender: TObject);
    procedure itmPasteStringsClick(Sender: TObject);
    procedure itmMovePathClick(Sender: TObject);
    procedure lstbxMsgPathsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstbxMsgPathsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lstbxMsgPathsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    procedure MoveRange(AListBox: TListBox; ABeg, ACount, ADest: Integer);
  public
    { Public declarations }
  end;

procedure ShowPrgOpt;

var
  frmPrgOpt: TfrmPrgOpt;
  PathR: TRange;

implementation

uses EditMSG;

{$R *.DFM}

procedure ShowPrgOpt;
begin
  with TfrmPrgOpt.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmPrgOpt.FormShow(Sender: TObject);
var i: Integer;
begin //      
  ckbxRunLastFile.Checked := PrgOpt.RunLastFile;
  cmbxAddNumComm.Text := IntToStr(PrgOpt.AddNumComm);
  ckbxAddNumComm.Checked := not(PrgOpt.AddNumComm=0);
  ckbxAddNumCommClick(Sender);
  ckbxRunScrMsg.Checked := PrgOpt.RunScriptMsg;
  for i:=0 to Length(PrgOpt.MsgPath)-1 do
    lstbxMsgPaths.Items.Add(PrgOpt.MsgPath[i]);
  ckbxCod1C.Checked := PrgOpt.SetCod1C; //    1
end;

procedure TfrmPrgOpt.FormClose(Sender: TObject; var Action: TCloseAction);
var i: Integer;
begin //       
  PrgOpt.RunLastFile := ckbxRunLastFile.Checked;
  PrgOpt.AddNumComm := StrToInt(cmbxAddNumComm.Text);
  PrgOpt.RunScriptMsg := ckbxRunScrMsg.Checked;
  SetLength(PrgOpt.MsgPath, lstbxMsgPaths.Items.Count);
  for i:=0 to lstbxMsgPaths.Items.Count-1 do
    PrgOpt.MsgPath[i] := lstbxMsgPaths.Items[i];
  PrgOpt.SetCod1C := ckbxCod1C.Checked; //    1
end;



procedure TfrmPrgOpt.cmbxAddNumCommKeyPress(Sender: TObject;
  var Key: Char);
begin
  Key := #0;
end;

procedure TfrmPrgOpt.ckbxRunScrMsgClick(Sender: TObject);
begin
  with lstbxMsgPaths do
  begin
    Enabled := ckbxRunScrMsg.Checked;
    if Enabled then Color := clWindow else Color := clBtnFace;
  end;
end;

procedure TfrmPrgOpt.cmbxAddNumCommChange(Sender: TObject);
begin //     ComboBox'
  if (cmbxAddNumComm.Text = '') or (StrToInt(cmbxAddNumComm.Text)<10) then
    cmbxAddNumComm.Text := '10'; //    ComboBox'
end;

procedure TfrmPrgOpt.ckbxAddNumCommClick(Sender: TObject);
begin
  with cmbxAddNumComm do
  begin
    if not(ckbxAddNumComm.Checked) then Text := '0' else Text := '10';
    Enabled := ckbxAddNumComm.Checked;
    if Enabled then Color := clWindow else Color := clBtnFace;
  end;
end;

procedure TfrmPrgOpt.MoveRange(AListBox: TListBox; ABeg, ACount, ADest: Integer);
var i: Integer;
begin //      TListBox
  if ADest<ABeg then
    for i:=0 to ACount-1 do
      AListBox.Items.Move(ABeg+i, ADest+i);
  if ADest>ABeg+ACount-1 then
    for i:=0 to ACount-1 do
      AListBox.Items.Move(ABeg, ADest);
end;

procedure TfrmPrgOpt.pmnMsgPathsPopup(Sender: TObject);
begin //  
  itmMovePath.Enabled := lstbxMsgPaths.Items.Count>1;
end;

procedure TfrmPrgOpt.itmAddPathClick(Sender: TObject);
var
  Dir: string;
  i: Integer;
begin //  
  if SelectDirectory('   msg-:', '', Dir) then
    with lstbxMsgPaths do
    begin
      for i:=0 to Items.Count-1 do //   ,    
        if AnsiLowerCase(Items[i])=AnsiLowerCase(IncludeTrailingBackslash(Dir)) then Exit;
      Items.Add(IncludeTrailingBackslash(Dir));
    end;
end;

procedure TfrmPrgOpt.itmPasteStringsClick(Sender: TObject);
var i, j, ACount: Integer;
begin //     
  with frmEditMsg.rcdtTempMSG do
  begin
    Text := '';
    PasteFromClipboard;
    if Text='' then Exit;
    ACount := lstbxMsgPaths.Items.Count;
    for i:=0 to Lines.Count-1 do
    begin
      if (Lines[i]='') or not(DirectoryExists(Lines[i])) then Continue;
      for j:=0 to ACount-1 do
        if Lines[i]=lstbxMsgPaths.Items[j] then Break;
      if (j>ACount-1) then lstbxMsgPaths.Items.Add(Lines[i]);
    end;
  end;
end;

procedure TfrmPrgOpt.itmMovePathClick(Sender: TObject);
begin //   
  with lstbxMsgPaths do
    if Items.Count>1 then
    begin
      LockWindowUpdate(frmPrgOpt.Handle);
      MultiSelect := True;
      Cursor := crHandPoint;
      LockWindowUpdate(0);
    end;
end;

procedure TfrmPrgOpt.lstbxMsgPathsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: Integer;
begin //  
  with lstbxMsgPaths do
  begin
    if (key=VK_ESCAPE) and MultiSelect then // * Esc *
    begin //     
      Cursor := crDefault;
      MultiSelect := False;
      SetFocus;
      Key:=0;
    end;
    if MultiSelect then
    begin
      Key := 0;
      Exit;
    end
    else //     MultiSelect
    begin
      if (Key=VK_UP) and (ssCtrl in Shift) then //   + Ctrl
      begin //       
        if ItemIndex>0 then Items.Exchange(ItemIndex, ItemIndex-1);
        Key := 0;
      end;
      if (Key=VK_DOWN) and (ssCtrl in Shift) then //   + Ctrl
      begin //       
        if (ItemIndex>-1) and (ItemIndex<Items.Count-1) then Items.Exchange(ItemIndex, ItemIndex+1);
        Key := 0;
      end;
      if (Key=VK_DELETE) and (ItemIndex>=0) then // Delete
      begin
        i := ItemIndex;
        Items.Delete(i); // 
        if Items.Count>=0 then
        begin
          if i>0 then ItemIndex:=i
          else ItemIndex:=0;
        end
      end;
    end;
  end;
end;

procedure TfrmPrgOpt.lstbxMsgPathsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //     
  with lstbxMsgPaths do
  begin
    pmnMsgPaths.AutoPopup := not(MultiSelect);
    if (Button=mbRight) and MultiSelect then //  
    begin //     
      Cursor := crDefault;
      MultiSelect := False;
      SetFocus;
    end;
  end;
end;

procedure TfrmPrgOpt.lstbxMsgPathsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //    
  with lstbxMsgPaths do begin
    if (Button=mbLeft) and (Cursor=crDrag) then //  
    begin //     
      MoveRange(lstbxMsgPaths, PathR.B, PathR.C, ItemIndex); //   
      Cursor := crDefault;
      MultiSelect := False;
    end;

    if (Button=mbLeft) and (lstbxMsgPaths.Cursor=crHandPoint) then //  
    begin //      
      PathR.B := 0;
      while PathR.B<Items.Count do
      begin
        if Selected[PathR.B] then Break;
        Inc(PathR.B);
      end;
      PathR.C := SelCount;
      Cursor := crDrag;
      //stsbrMain.Panels[0].Text := ' ,       ';
    end;
  end;
end;

end.
