unit MathPNO;

interface

uses SysUtils;

type
  TScobPos = array[0..3, 1..2] of Integer;
  TKeyWords = array[1..40] of string;

  function ReplaceInString(const ss1, ss2: string; var s: string): Cardinal;
  //function PosTS(ss, s:string; t: Cardinal): Cardinal;
  function PosFigured(const ALine: string; const APos: Integer; var APosB, APosE: Integer):string;
  function StrWinToDos(const Str: string): string;
  function StrDosToWin(const Str: string): string;
  function StrDosToWinSpec(const Str: string; var a: TScobPos): string;
  function PosTf(const ss, s: string; const t: Integer): Integer;
  function PosTr(const ss, s: string; const t: Integer): Integer;
  function GetNumFromMSG(const AStr: string): Integer;
  function GetStrFromMSG(const AStr: string): string;
  function GetIntFromStr(const AStr: string): Integer;
  function AddSpacesInStr(const AStr: string; const NPos: Integer): string;
  function DelCRLeft(const AStr: string): string;
  function WordInKeyWords(const AWord: string): Boolean;

var
  AKeyWords: TKeyWords = ('procedure', 'variable', 'import', 'export', 'in',
                           'when', 'begin' ,'end', 'exit', 'detach', 'fork',
                           'spawn', 'callstart', 'exec', 'noop', 'wait', 'call',
                           'cancel', 'cancelall', 'if', 'then', 'else', 'and',
                           'or', 'bwand', 'bwor', 'bwnot', 'bwxor', 'not',
                           'floor', 'return', 'do', 'while', 'include',
                           'startcritical', 'endcritical', 'critical', 'true',
                           'false', 'define');

implementation


function ReplaceInString(const ss1, ss2: string; var s: string): Cardinal;
(************************************************************************)
(*     s   ss1     ss2       *)
(*                                *)
(************************************************************************)
var
  ptz: Integer;
begin //    
  Result := 0;
  ptz := PosTf(ss1, s, 1);
  while ptz>0 do
  begin
    Delete(s, ptz, Length(ss1));
    Insert(ss2, s, ptz);
    ptz := PosTf(ss1, s, ptz+Length(ss2)-1);
    Result := Result + 1;
  end;
end; 

(*
function PosTS(ss, s: string; t: Cardinal): Cardinal;
var  lss, ls: Cardinal;
begin //    ss   s    t
  Result:=0;
  if t=0 then t:=1;
  lss:=Length(ss);
  ls:=Length(s);
  if (ls=0) or (lss=0) or (lss>ls) or (t>ls) then Exit;
  s:=Copy(s, t, ls);
  Result:=Pos(ss, s);
  if Result<>0 then Result:=Result + t - 1;
end;
*)

function PosTf(const ss, s: string; const t: Integer): Integer;
(************************************************************************)
(*     s  ss    t   s  *)
(*    ,  -1                             *)
(************************************************************************)
var
  lss, ls: Integer;
begin //     
  Result := -1;
  lss := Length(ss);
  ls := Length(s);
  if (ls=0) or (lss=0) or (t+lss-1>ls) then Exit; //  or (t>ls)  
  Result := t;
  if Result=0 then Result :=1; //       
  while Result<=ls do
  begin
    if Copy(s, Result, lss)=ss then Exit;
    Result := Result + 1;
  end;
  Result := -1;
end;

function PosTr(const ss, s: string; const t: Integer): Integer;
(************************************************************************)
(*     s  ss    t   s *)
(*    ,  -1                              *)
(************************************************************************)
var
  lss, ls: Integer;
begin //     
  Result := -1;
  lss := Length(ss);
  ls := Length(s);
  if (ls=0) or (lss=0) or (t-lss<0) then Exit; //  or (t>ls)  
  Result := t - lss;
  while Result>=0 do
  begin
    if Copy(s, Result, lss)=ss then Exit;
    Result := Result - 1;
  end;
  Result := -1;
end;

function PosFigured(const ALine: string; const APos: Integer; var APosB, APosE: Integer):string;
begin //     ,     ,  ''
  Result := '';
  APosB := APos - 1; APosE := APos;
  if (Length(ALine)<2) or (APos<=0) or (APos>Length(ALine)) then Exit;
  while ALine[APosB]<>'{' do
    if (APosB>1) and (ALine[APosB]<>'}') then APosB := APosB - 1 else Exit;
  while (ALine[APosE]<>'}') do
    if (APosE<Length(ALine)) and (ALine[APosE]<>'{') then APosE := APosE + 1 else Exit;
  //    ,    
  APosE := APosE + 1;
  Result := Copy(ALine, APosB, APosE-APosB);
end;

function StrWinToDos(const Str: string): string;
var i: Integer;
begin //    Dos  Win
  Result := '';
  for i:=1 to Length(Str) do
    if (Ord(Str[i])>=192) and (Ord(Str[i])<=239) then
      Result := Result + Chr(Ord(Str[i])-64)
    else
    begin
      if (Ord(Str[i])>=240) then //and (Ord(Str[i])<=255)
        Result := Result + Chr(Ord(Str[i])-16)
      else Result := Result + Str[i];
    end;
end;

function StrDosToWin(const Str: string): string;
var i: Integer;
begin
  Result := '';
  for i:=1 to Length(Str)+1 do
    if (Ord(Str[i])>=128) and (Ord(Str[i])<=175) then
      Result := Result + Chr(Ord(Str[i])+64)
    else
    begin
      if (Ord(Str[i])>=224) and (Ord(Str[i])<=239) then
        Result := Result + Chr(Ord(Str[i])+16)
      else Result := Result + Str[i];
    end;
end;

function StrDosToWinSpec(const Str: string; var a: TScobPos): string;
var i: Integer;
begin //    Dos  Win,    {} 
  Result := '';
  a[0,1] := 0;
  a[0,2] := 0;
  for i:=1 to Length(Str)+1 do
    if (Ord(Str[i])>=128) and (Ord(Str[i])<=175) then
      Result := Result + Chr(Ord(Str[i])+64)
    else
    begin
      if (Ord(Str[i])>=224) and (Ord(Str[i])<=239) then
        Result := Result + Chr(Ord(Str[i])+16)
      else
      begin
        Result := Result + Str[i];
        if Str[i]='{' then
        begin
          a[0,1] := a[0,1] + 1;
          a[a[0,1],1] := i;
        end;
        if Str[i]='}' then
        begin
          a[0,2] := a[0,2] + 1;
          a[a[0,2],2] := i;
        end;
      end;
    end;
end;

function GetNumFromMSG(const AStr: string): Integer;
begin //    "123<m>",   123
  Result := StrToInt(Copy(AStr, 1, Pos('<m>', AStr)-1));
end;

function GetStrFromMSG(const AStr: string): string;
var ATmp: Integer;
begin //    "123<m>",   ""
  ATmp := Pos('<m>', AStr);
  Result := Copy(AStr, ATmp+3, Length(AStr)-ATmp+3);
end;

function GetIntFromStr(const AStr: string): Integer;
var AErr: Integer;
begin //     
  Val(AStr, Result, AErr);
end;

function AddSpacesInStr(const AStr: string; const NPos: Integer): string;
var
  NSpace, i: Integer;
  TmpStr: string;
begin //      
  NSpace := NPos - Length(AStr);
  SetLength(TmpStr, NSpace);
  for i:=1 to NSpace do TmpStr[i] := ' ';
  Result := TmpStr;
end;

function DelCRLeft(const AStr: string): string;
var i: Integer;
begin //       
  i := 1;
  while (i<=Length(AStr)) and ((AStr[i]=#13) or (AStr[i]=#10)) do Inc(i);
  Result := Copy(AStr, i, Length(AStr)-i+1);
end;
{
function DelSpacesFromStr(const AStr: string): string;
var i: Integer;
begin //      
  i := 1;
  while (i<=Length(AStr)) and ((AStr[i]=#13) or (AStr[i]=#10)) do Inc(i);
  Result := Copy(AStr, i, Length(AStr)-i+1);
end;
}
function WordInKeyWords(const AWord: string): Boolean;
var i: Integer;
begin //    AWord    AKeyWords
  Result := False;
  for i:=1 to Length(AKeyWords) do
    if AWord=AKeyWords[i] then
    begin
      Result := True;
      Break;
    end;
end;

end.
