unit WorkINI;

interface

uses SysUtils, IniFiles, Forms, Menus, Graphics, ShellAPI, StdCtrls; //, Dialogs;

  procedure LoadFormStatFromINI;
  procedure SaveFormStatToINI;
  procedure SaveProgToINI(const ANameProg: string; const ACount: Integer);
  procedure SaveActProgToINI(const ACount: Integer);
  procedure SaveAllProgToINI(const ActPr: Integer; APopup: TPopupMenu);
  procedure LoadProgFromINI(APopup: TPopupMenu);
  procedure ChangeProgInINI(const ACount: Integer);
  procedure SavePathsToINI;
  procedure LoadPathsToINI;
  procedure LoadHistoryFromINI(APopup: TPopupMenu);
  procedure SaveHistoryToINI(APopup: TPopupMenu);
  procedure SaveComboHistoryToINI(ACombo: TComboBox; const ASectionName: string);
  procedure LoadComboHistoryFromINI(ACombo: TComboBox; const ASectionName: string);
  procedure SavePrgOptToINI;
  procedure LoadPrgOptFromINI;
  procedure SaveShblToINI(ShblName: String);
  function LoadShblFromINI: String;
  procedure SaveLstPathToINI(APath: String);
  function LoadLstPathFromINI: string;
  procedure SaveMiscOptToINI;
  procedure LoadMiscOptFromINI;
  //function NProgFromINI: Integer;
  //function IncNProgInINI: Integer;
  //function DecNProgInINI: Integer;

const ININame = 'fgeck.ini';

implementation

uses untMain, untPrgOpt;

procedure SaveFormStatToINI;
var
  ATempINI: TIniFile;
begin //     INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    //   frmMain
    ATempINI.WriteBool('MainFormPos', 'StatMax', StatMainFrm.Max);
    ATempINI.WriteInteger('MainFormPos', 'Left', StatMainFrm.Left);
    ATempINI.WriteInteger('MainFormPos', 'Top', StatMainFrm.Top);
    ATempINI.WriteInteger('MainFormPos', 'Width', StatMainFrm.Width);
    ATempINI.WriteInteger('MainFormPos', 'Height', StatMainFrm.Height);
    //   frmEditMsg
    ATempINI.WriteBool('DlgEditPos', 'StatMax', StatDlgEdit.Max);
    ATempINI.WriteInteger('DlgEditPos', 'Left', StatDlgEdit.Left);
    ATempINI.WriteInteger('DlgEditPos', 'Top', StatDlgEdit.Top);
    ATempINI.WriteInteger('DlgEditPos', 'Width', StatDlgEdit.Width);
    ATempINI.WriteInteger('DlgEditPos', 'Height', StatDlgEdit.Height);
    //   frmScriptShow
    ATempINI.WriteBool('ScrShowPos', 'StatMax', StatScrShow.Max);
    ATempINI.WriteInteger('ScrShowPos', 'Left', StatScrShow.Left);
    ATempINI.WriteInteger('ScrShowPos', 'Top', StatScrShow.Top);
    ATempINI.WriteInteger('ScrShowPos', 'Width', StatScrShow.Width);
    ATempINI.WriteInteger('ScrShowPos', 'Height', StatScrShow.Height);
    //   frmPrepr
    ATempINI.WriteBool('PreprPos', 'StatMax', StatPrepr.Max);
    ATempINI.WriteInteger('PreprPos', 'Left', StatPrepr.Left);
    ATempINI.WriteInteger('PreprPos', 'Top', StatPrepr.Top);
    ATempINI.WriteInteger('PreprPos', 'Width', StatPrepr.Width);
    ATempINI.WriteInteger('PreprPos', 'Height', StatPrepr.Height);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadFormStatFromINI;
var
  ATempINI: TIniFile;
begin //     INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    //   frmMain
    StatMainFrm.Max := ATempINI.ReadBool('MainFormPos', 'StatMax', False);
    StatMainFrm.Left := ATempINI.ReadInteger('MainFormPos', 'Left', 2);
    StatMainFrm.Top := ATempINI.ReadInteger('MainFormPos', 'Top', 2);
    StatMainFrm.Width := ATempINI.ReadInteger('MainFormPos', 'Width', 700);
    StatMainFrm.Height := ATempINI.ReadInteger('MainFormPos', 'Height', 500);
    //   frmEditMsg
    StatDlgEdit.Max := ATempINI.ReadBool('DlgEditPos', 'StatMax', False);
    StatDlgEdit.Left := ATempINI.ReadInteger('DlgEditPos', 'Left', 200);
    StatDlgEdit.Top := ATempINI.ReadInteger('DlgEditPos', 'Top', 140);
    StatDlgEdit.Width := ATempINI.ReadInteger('DlgEditPos', 'Width', 600);
    StatDlgEdit.Height := ATempINI.ReadInteger('DlgEditPos', 'Height', 420);
    //   frmScriptShow
    StatScrShow.Max := ATempINI.ReadBool('ScrShowPos', 'StatMax', False);
    StatScrShow.Left := ATempINI.ReadInteger('ScrShowPos', 'Left', 60);
    StatScrShow.Top := ATempINI.ReadInteger('ScrShowPos', 'Top', 60);
    StatScrShow.Width := ATempINI.ReadInteger('ScrShowPos', 'Width', 750);
    StatScrShow.Height := ATempINI.ReadInteger('ScrShowPos', 'Height', 550);
    //   frmPrepr
    StatPrepr.Max := ATempINI.ReadBool('PreprPos', 'StatMax', False);
    StatPrepr.Left := ATempINI.ReadInteger('PreprPos', 'Left', 60);
    StatPrepr.Top := ATempINI.ReadInteger('PreprPos', 'Top', 60);
    StatPrepr.Width := ATempINI.ReadInteger('PreprPos', 'Width', 750);
    StatPrepr.Height := ATempINI.ReadInteger('PreprPos', 'Height', 550);
  finally
    ATempINI.Free;
  end;
end;

procedure SaveAllProgToINI(const ActPr: Integer; APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  i: Word;
begin //       INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteInteger('ProgStart', 'StartPos', ActPr-1);
    for i:=2 to ASizeMnuProg do
      if i<=APopup.ComponentCount then
        ATempINI.WriteString('ProgStart', 'Pr'+IntToStr(i-1), APopup.Items[i].Caption)
      else ATempINI.WriteString('ProgStart', 'Pr'+IntToStr(i-1), '');
  finally
    ATempINI.Free;
  end;
end;

procedure SaveProgToINI(const ANameProg: string; const ACount: Integer);
var
  ATempINI: TIniFile;
begin //       INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteString('ProgStart', 'Pr'+IntToStr(ACount-1), ANameProg);
  finally
    ATempINI.Free;
  end;
end;

procedure SaveActProgToINI(const ACount: Integer);
var
  ATempINI: TIniFile;                        
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteInteger('ProgStart', 'StartPos', ACount-1)
  finally
    ATempINI.Free;
  end;
end;


procedure LoadProgFromINI(APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  i: byte;
  ANameProg, ANameAct: string;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    i := 1;
    ActPr := ATempINI.ReadInteger('ProgStart', 'StartPos', -1);
    repeat
      ANameProg := ATempINI.ReadString('ProgStart', 'Pr'+IntToStr(i), '');
      if ANameProg<>'' then //    
      begin
        if FileExists(ANameProg) then //   
          frmMain.AddNewProcToMenu(ANameProg, APopup)
        else ActPr := -1;
        if ActPr=i then ANameAct := ANameProg;
      end
      else if ActPr=i then ActPr:=-1; //     . 
      i := i + 1;
    until (i>ASizeMnuProg);// or (ANameProg=''); //   .
    if (ActPr>0) and (ActPr<=APopup.ComponentCount-1) then //       
    begin
      ActPr := ActPr + 1;
      frmMain.ChangeIconProg(ANameAct, -1); //   
    end
    else
    begin
      ActPr:=-1;
      SaveAllProgToINI(ActPr, frmMain.pmnProgStart);
    end;
  finally
    ATempINI.Free;
  end;
end;

procedure ChangeProgInINI(const ACount: Integer);
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteInteger('ProgStart', 'StartPos', ACount-1);
  finally
    ATempINI.Free;
  end;
end;

procedure SavePathsToINI;
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteString('Paths', 'OpenScript', frmMain.opndlgOpenScript.InitialDir);
    ATempINI.WriteString('Paths', 'SaveScript', frmMain.svdlgSaveScript.InitialDir);
    ATempINI.WriteString('Paths', 'NewProg', frmMain.opndlgNewProg.InitialDir);
    //ATempINI.WriteString('Paths', 'DecompilerDir', frmMain.opndlgDecompile.InitialDir);
    ATempINI.WriteString('Paths', 'Decompiler', PrgOpt.Decompiler);
    ATempINI.WriteString('Paths', 'DecompileDir', PrgOpt.DecompileDir);
    ATempINI.WriteString('ProgOptions', 'DecompilerKey', PrgOpt.DecompilerKey);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadPathsToINI;
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    frmMain.opndlgOpenScript.InitialDir := ATempINI.ReadString('Paths', 'OpenScript', '');
    frmMain.svdlgSaveScript.InitialDir := ATempINI.ReadString('Paths', 'SaveScript', '');
    frmMain.opndlgNewProg.InitialDir := ATempINI.ReadString('Paths', 'NewProg', '');
    //frmMain.opndlgDecompile.InitialDir := ATempINI.ReadString('Paths', 'DecompilerDir', '');
    PrgOpt.Decompiler := ATempINI.ReadString('Paths', 'Decompiler', '');
    PrgOpt.DecompileDir := ATempINI.ReadString('Paths', 'DecompileDir', '');
    PrgOpt.DecompilerKey := ATempINI.ReadString('ProgOptions', 'DecompilerKey', '');
  finally
    ATempINI.Free;
  end;
end;

procedure LoadHistoryFromINI(APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  AMnuItem: TMenuItem;
  i: byte;
  ANameProg: string;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    i := 1;
    repeat
      ANameProg := ATempINI.ReadString('History', 'h'+IntToStr(i), '');
      if (ANameProg<>'') then //    
        if (ExtractFileExt(ANameProg)='.ssl') and FileExists(ANameProg) then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := ANameProg;
          AMnuItem.Tag := ATempINI.ReadInteger('History', 'hp'+IntToStr(i), 0);
          AMnuItem.OnClick := frmMain.itmHistoryClick; //  
        end;
      i := i + 1;
    until (i>ASizeMnuHistory);// or (ANameProg=''); //   .
  finally
    ATempINI.Free;
  end;
end;

procedure SaveHistoryToINI(APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  i: Word;
begin //       INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    for i:=0 to ASizeMnuHistory-1 do
      if (i<APopup.Items.Count) and (ExtractFileExt(APopup.Items[i].Caption)='.ssl') then
      begin
        ATempINI.WriteString('History', 'h'+IntToStr(i+1), APopup.Items[i].Caption);
        ATempINI.WriteInteger('History', 'hp'+IntToStr(i+1), APopup.Items[i].Tag);
      end
      else ATempINI.WriteString('History', 'h'+IntToStr(i+1), '');
  finally
    ATempINI.Free;
  end;
end;

procedure LoadComboHistoryFromINI(ACombo: TComboBox; const ASectionName: string);
var
  ATempINI: TIniFile;
  i: byte;
  ATempStr: string;
begin //   ComboBox   ASectionName  INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    i := 1;
    repeat
      ATempStr := ATempINI.ReadString(ASectionName, 'hcb'+IntToStr(i), '');
      if ATempStr<>'' then ACombo.Items.Add(ATempStr);
      i := i + 1;
    until (ATempStr='');
  finally
    ATempINI.Free;
  end;
end;

procedure SaveComboHistoryToINI(ACombo: TComboBox; const ASectionName: string);
var
  ATempINI: TIniFile;
  i: Byte;
begin //   ComboBox   ASectionName  INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    if ACombo.Items.Count>0 then //    
      for i:=0 to ACombo.Items.Count-1 do
        ATempINI.WriteString(ASectionName, 'hcb'+IntToStr(i+1), ACombo.Items[i]);
  finally
    ATempINI.Free;
  end;
end;

procedure SavePrgOptToINI;
var
  ATempINI: TIniFile;
  i: Byte;
begin //    INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteBool('ProgOptions', 'RunLastFile', PrgOpt.RunLastFile);
    ATempINI.WriteBool('ProgOptions', 'RunEditMSG', PrgOpt.RunEditMSG);
    ATempINI.WriteBool('ProgOptions', 'CloseEditMSG', PrgOpt.CloseEditMSG);
    for i:=0 to SizeScrPath-1 do
      if i<Length(PrgOpt.ScrPath) then
        ATempINI.WriteString('ScrPath', 'p'+IntToStr(i+1), PrgOpt.ScrPath[i])
      else ATempINI.WriteString('ScrPath', 'p'+IntToStr(i+1), '');
    ATempINI.WriteString('Paths', 'PreprScriptPath', PrgOpt.PreprScriptPath);
    ATempINI.WriteString('Paths', 'HPath', PrgOpt.HPath);
    ATempINI.WriteString('Paths', 'HEditor', PrgOpt.HEditor);
    //ATempINI.WriteString('Paths', 'DecompilerDir', frmMain.opndlgDecompile.InitialDir);
    //ATempINI.WriteString('Paths', 'DecompilerPath', PrgOpt.DecompilerPath);
    //ATempINI.WriteString('Paths', 'DecompileDir', PrgOpt.DecompileDir);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadPrgOptFromINI;
var
  ATempINI: TIniFile;
  i: byte;
  APath: string;
begin //    INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    PrgOpt.RunLastFile := ATempINI.ReadBool('ProgOptions', 'RunLastFile', False);
    PrgOpt.RunEditMSG := ATempINI.ReadBool('ProgOptions', 'RunEditMSG', False);
    PrgOpt.CloseEditMSG := ATempINI.ReadBool('ProgOptions', 'CloseEditMSG', False);
    i := 1;
    repeat
      APath := ATempINI.ReadString('ScrPath', 'p'+IntToStr(i), '');
      if APath<>'' then
      begin
        SetLength(PrgOpt.ScrPath, i);
        PrgOpt.ScrPath[i-1] := APath;
      end;
      i := i + 1;
    until (i>SizeScrPath);
    PrgOpt.PreprScriptPath := ATempINI.ReadString('Paths', 'PreprScriptPath', '');
    PrgOpt.HPath := ATempINI.ReadString('Paths', 'HPath', '');
    PrgOpt.HEditor := ATempINI.ReadString('Paths', 'HEditor', '');
    //frmMain.opndlgDecompile.InitialDir := ATempINI.ReadString('Paths', 'DecompileDir', '');
    //PrgOpt.DecompilerPath := ATempINI.ReadString('Paths', 'DecompilerPath', '');
    //PrgOpt.DecompilerPath := ATempINI.ReadString('Paths', 'DirDecompile', '');
  finally
    ATempINI.Free;
  end;
end;

procedure SaveShblToINI(ShblName: String);
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteString('ProgOptions', 'ShblName', ExtractFileName(ShblName));
  finally
    ATempINI.Free;
  end;
end;

function LoadShblFromINI: String;
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    Result := ATempINI.ReadString('ProgOptions', 'ShblName', '');
  finally
    ATempINI.Free;
  end;
end;

procedure SaveLstPathToINI(APath: String);
var ATempINI: TIniFile;
begin //    lst   INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteString('Paths', 'Lst', APath);
  finally
    ATempINI.Free;
  end;
end;

function LoadLstPathFromINI: string;
var ATempINI: TIniFile;
begin //    lst   INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    Result := ATempINI.ReadString('Paths', 'Lst', '');
  finally
    ATempINI.Free;
  end;
end;

procedure SaveMiscOptToINI;
var
  ATempINI: TIniFile;
begin //    
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteInteger('MiscOptions', 'PnlNavSize', MiscOpt.PnlNavSize);
    ATempINI.WriteInteger('MiscOptions', 'PnlSnipSize', MiscOpt.PnlSnipSize);
    ATempINI.WriteBool('MiscOptions', 'PnlSnipShow', MiscOpt.PnlSnipShow);
    ATempINI.WriteBool('MiscOptions', 'TreeDragDrop', MiscOpt.TreeDragDrop);
    ATempINI.WriteInteger('MiscOptions', 'AProc', MiscOpt.AProc);
    ATempINI.WriteInteger('MiscOptions', 'ANum', MiscOpt.ANum);
    ATempINI.WriteInteger('MiscOptions', 'AMsg', MiscOpt.AMsg);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadMiscOptFromINI;
var
  ATempINI: TIniFile;
begin //    
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    MiscOpt.PnlNavSize := ATempINI.ReadInteger('MiscOptions', 'PnlNavSize', 120);
    MiscOpt.PnlSnipSize := ATempINI.ReadInteger('MiscOptions', 'PnlSnipSize', 120);
    MiscOpt.PnlSnipShow := ATempINI.ReadBool('MiscOptions', 'PnlSnipShow', True);
    MiscOpt.TreeDragDrop := ATempINI.ReadBool('MiscOptions', 'TreeDragDrop', True);
    MiscOpt.AProc := ATempINI.ReadInteger('MiscOptions', 'AProc', 70);
    MiscOpt.ANum := ATempINI.ReadInteger('MiscOptions', 'ANum', 45);
    MiscOpt.AMsg := ATempINI.ReadInteger('MiscOptions', 'AMsg', 500);
  finally
    ATempINI.Free;
  end;
end;

(*
function NProgFromINI: Integer;
var
  ATempINI: TIniFile;
begin //    fgeck  
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    Result := ATempINI.ReadInteger('ProgOptions', 'NProg', 0);
    //if Result=0 then ATempINI.WriteInteger('ProgOptions', 'NProg', 1);
  finally
    ATempINI.Free;
  end;
end;


function IncNProgInINI: Integer;
var
  ATempINI: TIniFile;
begin //    fgeck  
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    //ShowMessage(ASelfPath + ININame);
    Result := ATempINI.ReadInteger('ProgOptions', 'NProg', 0);
    Inc(Result);
    ATempINI.WriteInteger('ProgOptions', 'NProg', Result);
  finally
    ATempINI.Free;
  end;
end;

function DecNProgInINI: Integer;
var
  ATempINI: TIniFile;
begin //    fgeck  
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    Result := ATempINI.ReadInteger('ProgOptions', 'NProg', 0);
    if Result>0 then
    begin
      Dec(Result);
      ATempINI.WriteInteger('ProgOptions', 'NProg', Result);
    end;
  finally
    ATempINI.Free;
  end;
end;
*)

end.
