unit untPrepr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SynMemo, ComCtrls, SynEditHighlighter, SynUniHighlighter, Menus,
  StdCtrls, ToolWin, Buttons, ExtCtrls, ImgList, Clipbrd, FileCtrl, ShellAPI;

type
  TfrmPreprShow = class(TForm)
    stsbrPrepr: TStatusBar;
    pgcntrlPrepr: TPageControl;
    mnuPopPrepr: TPopupMenu;
    itmCopyOnlyL: TMenuItem;
    tlbrPrepr: TToolBar;
    edtFindPrepr: TComboBox;
    tlbtnSep1: TToolButton;
    tlbtnSep2: TToolButton;
    tlbtnFindDownPrepr: TToolButton;
    tlbtnFindUpPrepr: TToolButton;
    tlbtnAllHeadersPrepr: TToolButton;
    imglstFindPrepr: TImageList;
    mnuPopAllHeader: TPopupMenu;
    opndlgOpenH: TOpenDialog;
    TlBtnRereadH: TToolButton;
    TlBtnEditH: TToolButton;
    tlbtnSep3: TToolButton;
    mnuPopPage: TPopupMenu;
    mnuCloseActive: TMenuItem;
    mnuCloseAllExtActive: TMenuItem;
    N2: TMenuItem;
    tmrAntiCombo: TTimer;
    tlbtnSep4: TToolButton;
    tlbtnOpenAll: TToolButton;
    tlbtnOpenInclude: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure mProcPreprKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mScriptShowKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mProcPreprClick(Sender: TObject);
    procedure tlbtnFindDownPreprClick(Sender: TObject);
    procedure itmCopyOnlyLClick(Sender: TObject);
    procedure edtFindPreprExit(Sender: TObject);
    procedure tlbtnFindUpPreprClick(Sender: TObject);
    procedure edtFindPreprDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure edtFindPreprDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure tlbtnAllHeadersPreprClick(Sender: TObject);
    procedure edtFindPreprKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtFindPreprEnter(Sender: TObject);
    procedure itmAllHeadersClick(Sender: TObject);
    procedure TlBtnRereadHClick(Sender: TObject);
    procedure TlBtnEditHClick(Sender: TObject);
    procedure pgcntrlPreprMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuPopPreprPopup(Sender: TObject);
    procedure mnuCloseActiveClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure tmrAntiComboTimer(Sender: TObject);
    procedure pgcntrlPreprChange(Sender: TObject);
    procedure tlbtnOpenAllClick(Sender: TObject);
    procedure tlbtnOpenIncludeClick(Sender: TObject);
    procedure mnuCloseAllExtActiveClick(Sender: TObject);
  private
    { Private declarations }
    function AddNewPageForPrepr(const ANameProc: string): TSynMemo;
    procedure HFileLoadShow(TmpMemo: TSynMemo);
    procedure FillAllHeaders;
    function GetHeaderOpen(HName: string): Boolean;
    function ActivePreprMemo: TSynMemo;
    function IndexPreprMemo(const Ind: Integer): TSynMemo;
    procedure IncludeFind(var AMemo: TSynMemo);
    procedure EnabledControl;
  public
    { Public declarations }
  end;

procedure PreprShow(HShow: Boolean);

var
  frmPreprShow: TfrmPreprShow;
  PreprUIN: Cardinal = 0; //     
  HShowLocal: Boolean;
  FixActivePage: Integer;

implementation

uses untMain, MathPNO;

{$R *.DFM}

procedure PreprShow(HShow: Boolean);
begin
  HShowLocal:= HShow;

  with TfrmPreprShow.Create(Application) do
    if HShowLocal then
    begin
      FillAllHeaders;
      //frmMain.mnitmHShow.Visible := False;
      frmMain.tlbtnHShow.Enabled := False;
      frmMain.mnitmOpenScriptPrepr.Visible := False;
      Show;
    end
    else
      try
        tlbtnSep3.Visible := False;
        tlbtnAllHeadersPrepr.Visible := False;
        TlBtnRereadH.Visible := False;
        TlBtnEditH.Visible := False;
        tlbtnOpenInclude.Visible := False;
        tlbtnOpenAll.Visible := False;
        tlbtnSep1.Visible := False;
        //tlbtnSep4.Visible := False;
        //tlbtnSep3.Visible := False;
        mnuPopPage.AutoPopup := False;
        
        ShowModal;
      finally
        Free;
      end;
end;

procedure TfrmPreprShow.FillAllHeaders;
var
  NewItem: TMenuItem;
  fs: TSearchRec;
begin
  if (PrgOpt.HPath<>'') and DirectoryExists(PrgOpt.HPath) then
    try
      if FindFirst(PrgOpt.HPath+'\*.h',faAnyFile-faDirectory-faVolumeID, fs)=0 then
        with mnuPopAllHeader.Items do
          repeat
            NewItem := TMenuItem.Create(mnuPopAllHeader);
            Add(NewItem);
            NewItem.Caption := AnsiLowerCase(fs.Name);
            NewItem.OnClick := itmAllHeadersClick;
            if ((Count-1) div 20)=((Count-1)/20) then //  mnuPopAllHeader.Items.Count-1  20
              NewItem.Break := mbBarBreak; //     
          until FindNext(fs)<>0
    finally
      FindClose(fs);
    end;
end;

function TfrmPreprShow.GetHeaderOpen(HName: string): Boolean;
var i: Integer;
begin //       
  Result := False;
  for i:=0 to pgcntrlPrepr.PageCount-1 do
  if AnsiLowerCase(pgcntrlPrepr.Pages[i].Caption)=AnsiLowerCase(HName) then
  begin
    Result := True;
    pgcntrlPrepr.ActivePageIndex := i; //  
    Exit;
  end;
end;

procedure TfrmPreprShow.itmAllHeadersClick(Sender: TObject);
var
  HMemo: TSynMemo;
  FullHName: string;
  TempItem: TMenuItem;
begin //     "Headers"
  TempItem := TMenuItem(Sender);
  FullHName := PrgOpt.HPath + '\' + TempItem.Caption;
  if FileExists(FullHName) and not(GetHeaderOpen(TempItem.Caption)) then
  begin
    HMemo := AddNewPageForPrepr(AnsiLowerCase(TempItem.Caption));
    stsbrPrepr.Panels[0].Text := FullHName;
    HMemo.Lines.LoadFromFile(FullHName);
    IncludeFind(HMemo);
    {
    edtFindPrepr.Enabled := True;
    tlbtnFindDownPrepr.Enabled := True;
    tlbtnFindUpPrepr.Enabled := True;
    TlBtnRereadH.Enabled := True;
    TlBtnEditH.Enabled := FileExists(PrgOpt.HEditor); //   
     }
    EnabledControl;
  end;
end;

procedure TfrmPreprShow.IncludeFind(var AMemo: TSynMemo);
begin // ,     Me  #include
  AMemo.Tag := Pos('#include', AMemo.Text);
  //pgcntrlPreprChange(nil);
    tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
end;

procedure TfrmPreprShow.FormCreate(Sender: TObject);
begin
  Left := StatPrepr.Left;
  Top := StatPrepr.Top;
  Width := StatPrepr.Width;
  Height := StatPrepr.Height;
  if StatPrepr.Max then WindowState := wsMaximized;
  if not(HShowLocal) then Caption := CPreprScript + ' - [' + PrgOpt.PreprScriptPath + ']'
  else Caption := '     (*.h)';
end;

procedure TfrmPreprShow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin //   
  if WindowState = wsMaximized then StatPrepr.Max := True
  else
  begin
    StatPrepr.Max := False;
    StatPrepr.Left := Left;
    StatPrepr.Top := Top;
    StatPrepr.Width := Width;
    StatPrepr.Height := Height;
  end;
  frmMain.edtFind.Items := edtFindPrepr.Items;
  //frmMain.mnitmHShow.Visible := True;
  frmMain.tlbtnHShow.Enabled := True;
  frmMain.mnitmOpenScriptPrepr.Visible := True;
end;

procedure TfrmPreprShow.FormShow(Sender: TObject);
var NewMemo: TSynMemo;
begin //   
  TlBtnEditH.Enabled := FileExists(PrgOpt.HEditor); //   
  if not(HShowLocal) then
  begin
    NewMemo := AddNewPageForPrepr(ExtractFileName(PrgOpt.PreprScriptPath));
    NewMemo.Lines := frmMain.rcdtTemp.Lines;
  end
  else HFileLoadShow(frmMain.mInitial); //     
  edtFindPrepr.Items := frmMain.edtFind.Items;


  if AStrToModal<>'' then
  begin
    edtFindPrepr.Text := AStrToModal;
    AStrToModal := '';
  end;

  //edtFindPrepr.SetFocus;
  //edtFindPrepr.SelectAll;
  //edtFindPrepr.s
  //LockWindowUpdate(edtFindPrepr.Handle);
  //edtFindPrepr.SelStart := 0;
  //edtFindPrepr.SelLength := 0; //Length(edtFindPrepr.Text) - 1;

  //edtFindPrepr.SetFocus;
  

  //LockWindowUpdate(0);
  //edtFindPrepr.DroppedDown := True;
  //edtFindPrepr.Visible := False;
  //edtFindPrepr.Visible := True;

  //edtFindPrepr.SetFocus;
  //edtFindPrepr.SelectAll;
  //edtFindPrepr.SelStart := 0;
  //edtFindPrepr.Refresh;
  //edtFindPrepr.Repaint;

  if pgcntrlPrepr.PageCount=0 then
  begin
    edtFindPrepr.Enabled := False;
    tlbtnFindDownPrepr.Enabled := False;
    tlbtnFindUpPrepr.Enabled := False;
    TlBtnRereadH.Enabled := False;
    TlBtnEditH.Enabled := False;
  end;
end;

procedure TfrmPreprShow.HFileLoadShow(TmpMemo: TSynMemo);
var
  {TmpMemo,} HMemo: TSynMemo;
  i, psnb: Integer; //psh,
  HName, FullHName, HIPath, APath: string;
begin //         *.h
  //TmpMemo := AddNewPageForPrepr('temp');
  //TmpMemo.Lines := frmMain.mInitial.Lines;
  //TmpMemo.Lines := AMemo.Lines;
  //pgcntrlPrepr.Visible := False;
  if pgcntrlPrepr.ActivePageIndex>=0 then FixActivePage:=pgcntrlPrepr.ActivePageIndex
  else FixActivePage:=0;
  pgcntrlPrepr.Enabled := False;
  tlbrPrepr.Enabled := False;
  LockWindowUpdate(pgcntrlPrepr.Handle);
  for i:=0 to TmpMemo.Lines.Count do
  begin
    if Pos('#include', TmpMemo.Lines[i])<>0 then
    begin
      //psh := Pos('.h', TmpMemo.Lines[i]);
      //if psh=0 then Continue;
      //psnb := PosTr('\', TmpMemo.Lines[i], psh);
      //HName := Copy(TmpMemo.Lines[i], psnb+1, psh-psnb+1);

      HIPath := TmpMemo.Lines[i];
      Delete(HIPath, 1, Pos('"', HIPath)); //     "
      HIPath := Copy(HIPath, 1, Pos('"', HIPath)-1); //     "
      if Copy(HIPath, 1, 3)='..\' then
      begin //  #include  
        Delete(HIPath, 1, 3); //   ..\
        psnb := PosTr('\', PrgOpt.HPath, Length(PrgOpt.HPath));
        APath := Copy(PrgOpt.HPath, 1, psnb);
        FullHName := APath + HIPath;
      end
      else FullHName := HIPath; //  #include  
      //if FileExists(FullHName) and not(GetHeaderOpen(HName)) then
      HName := ExtractFileName(FullHName);
      if FileExists(FullHName) and not(GetHeaderOpen(HName)) then
      begin
        HMemo := AddNewPageForPrepr(AnsiLowerCase(HName));
        stsbrPrepr.Panels[0].Text := FullHName;
        HMemo.Lines.LoadFromFile(FullHName);
        HMemo.Tag := Pos('#include', HMemo.Text);
        if TrimRight(AnsiLowerCase(ExtractFileDir(FullHName)))<>TrimRight(AnsiLowerCase(PrgOpt.HPath)) then
          HMemo.Hint := FullHName;
      end;
    end;
  end;
  pgcntrlPrepr.ActivePageIndex := FixActivePage;
  LockWindowUpdate(0);
  tlbrPrepr.Enabled := True;
  pgcntrlPrepr.Enabled := True;
  EnabledControl;
end;

function TfrmPreprShow.AddNewPageForPrepr(const ANameProc: string): TSynMemo;
var
  NewMemo: TSynMemo;
begin //     PageControl,    Memo,     
  PrUIN := PrUIN + 1;
  with TTabSheet.Create(pgcntrlPrepr) do
  begin
    PageControl := pgcntrlPrepr;
    try
      Name := 'tbSheetPrepr' + IntToStr(PrUIN);
    except
      ShowMessage(' :       .');
    end;
    ImageIndex := -1; //  
    Caption := ANameProc;
  end;
  with pgcntrlPrepr do
  begin
    ActivePage := Pages[PageCount-1]; //   
    NewMemo := TSynMemo.Create(ActivePage); //    
    NewMemo.Parent := ActivePage; //  
  end;
  with NewMemo do
  begin
    Name := 'mProcPrepr' + IntToStr(PrUIN);
    ClearAll; // Clear,   TSynMemo ;
    Align := alClient;
    //OnClick := AllMemoOnClick;
    //OnEnter := AllMemoOnClick;
    //OnChange := mInitialChange;
    //OnKeyDown := mInitialKeyDown;
    //OnKeyUp := mInitialKeyUp;
    OnKeyDown := mProcPreprKeyDown; //   
    OnKeyUp := mScriptShowKeyUp;
    OnClick := mProcPreprClick;
    OnEnter := mProcPreprClick;
    PopupMenu := mnuPopPrepr;
    Font.Charset := RUSSIAN_CHARSET;

    gutter.Font.Name := 'Symbol';
    gutter.Font.Charset := SYMBOL_CHARSET;
    gutter.Font.Size := 8;
    gutter.ShowLineNumbers := True;
    gutter.LeftOffset := 0;
    gutter.LeadingZeros := True;
    gutter.DigitCount := 3;
    gutter.RightOffset := 3;
    //gutter := mInitial.Gutter;
    //WantTabs := True; //    Memo
    //TabWidth := 2;
    //Options := Options - [eoSmartTabs];
    Highlighter := frmMain.SynUniSSL; //SynUniSSLPrepr;
    ReadOnly := True;
    Visible := True;
    //Options := Options + [eoDropFiles]; //   
    //OnDropFiles := mInitialDropFiles; //   
    //NewMemo.SetFocus;
  end;
  Result := NewMemo;
end;

procedure TfrmPreprShow.mProcPreprKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin //  
  if Key=VK_F1 then //    F1
    with (Sender as TSynMemo) do
      if (WordAtCursor='') or (CaretX>Length(LineText)) then Application.HelpJump('StandFunc')
      else Application.HelpJump(WordAtCursor);
  if Key=VK_ESCAPE then // Esc
    ModalResult := mrCancel;
  if (ssCtrl in Shift) and (Key=77) then // Ctrl+"M"
  begin
    Key := 0;
    frmMain.SendNumMsgToEditMsg((Sender as TSynMemo).WordAtCursor); //   EditMsg      
  end;
end;

procedure TfrmPreprShow.mScriptShowKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin //   
  mProcPreprClick(Sender);
end;

procedure TfrmPreprShow.mProcPreprClick(Sender: TObject);
var
  ATempStr: String;
  AMemo: TSynMemo;
begin //    Memo
  AMemo := TSynMemo(Sender);
  with frmMain do
    if AMemo.SelText='' then
    begin
      ATempStr := SearchInData(AMemo.WordAtCursor);
      stsbrPrepr.Panels[0].Text := ATempStr;
    end;
end;

function TfrmPreprShow.ActivePreprMemo: TSynMemo;
begin //  Memo   
  Result := pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo;
end;

function TfrmPreprShow.IndexPreprMemo(const Ind: Integer): TSynMemo;
begin //  Memo   
  Result := pgcntrlPrepr.Pages[Ind].Controls[0] as TSynMemo;
end;

procedure TfrmPreprShow.tlbtnFindDownPreprClick(Sender: TObject);
var
  i: Integer;
  //ATempMemo: TSynMemo;
begin //  " "   
  if edtFindPrepr.Text='' then Exit;
  frmMain.AddTextInCombo(edtFindPrepr);

  with ActivePreprMemo do CaretXY := BlockEnd; //     
  i := pgcntrlPrepr.ActivePageIndex; //  GetActiveIndex;
  repeat
    if frmMain.FindAndReplace(edtFindPrepr.Text, '', IndexPreprMemo(i), False, False, False)<>0 then //
    begin
      if pgcntrlPrepr.ActivePageIndex<>i then pgcntrlPrepr.ActivePageIndex:=i; // SetActiveMemo(i);
      tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
      Exit;
    end;
    with IndexPreprMemo(i) do SelEnd := SelStart;
    Inc(i);
    if i<=pgcntrlPrepr.PageCount-1 then
    begin
      with IndexPreprMemo(i) do
      begin
        SelStart := 0;
        SelEnd := 0;
      end;
    end;
  until i>pgcntrlPrepr.PageCount-1;

  MessageBeep(MB_OK);
  pgcntrlPrepr.ActivePageIndex := 0; //SetActiveMemo(0);
  with ActivePreprMemo do
  begin
   SelStart := 0;
   SelEnd := 0;
   SetFocus;
  end;
{
  if MessageBox(Application.Handle,
     PChar(' .    ?'),
     PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
  begin //    (  )
    pgcntrlPrepr.ActivePageIndex := 0; //SetActiveMemo(0);
    with ActivePreprMemo do
    begin
     SelStart := 0;
     SelEnd := 0;
     SetFocus;
    end;
  end;   }
  ActivePreprMemo.SetFocus;
  tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
end;

{
procedure TfrmPreprShow.tlbtnFindDownPreprClick(Sender: TObject);
var
  ATempStr, ASStr: string;
  APos, i: Integer;
  ATempMemo: TSynMemo;
begin //     
  if edtFindPrepr.Text='' then Exit; //  ,    
  ANewPage := False;
  i := pgcntrlPrepr.ActivePageIndex;
  repeat
    ATempMemo := (pgcntrlPrepr.Pages[i].Controls[0] as TSynMemo);
    with ATempMemo do
    begin
      if ANewPage then APos := PosTf(ASStr, ATempStr, 0)
      else APos := PosTf(ASStr, ATempStr, SelEnd);
      if APos>=0 then
      begin
        if ANewPage then // ,    
        begin
          pgcntrlPrepr.ActivePage := pgcntrlPrepr.Pages[i];
          ANewPage := False; //     
        end;
        SetFocus;
        SelStart := APos;
        SelEnd := APos + Length(edtFindPrepr.Text);
        Exit;
      end
      else
      begin
        i := i + 1;
        ANewPage := True;
      end;
    end;
  until i>=pgcntrlPrepr.PageCount;
  if MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
    PChar(' .   ?'),
    PChar(' '), MB_ICONWARNING + MB_YESNO) = IDYES then
  begin //     (  )

    //NormCurAndCol;//(Sender); //   
    pgcntrlPrepr.ActivePage := pgcntrlPrepr.Pages[0];
    //NavigatorControl; //  
    with (pgcntrlPrepr.Pages[0].Controls[0] as TSynMemo) do  //mInitial
    begin
      SelStart := 0;
      SelEnd := 0;
      SetFocus;
    end;
  end;
end;
}

procedure TfrmPreprShow.itmCopyOnlyLClick(Sender: TObject);
begin // 
  (pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo).CopyToClipboard;
end;

procedure TfrmPreprShow.edtFindPreprExit(Sender: TObject);
begin //    edtFindPrepr
  //frmMain.AddTextInCombo(edtFindPrepr);
end;

procedure TfrmPreprShow.tlbtnFindUpPreprClick(Sender: TObject);
var i: Integer;
begin //  " "   
  if edtFindPrepr.Text='' then Exit;
  frmMain.AddTextInCombo(edtFindPrepr);

  with ActivePreprMemo do CaretXY := BlockBegin; //     
  i := pgcntrlPrepr.ActivePageIndex;  //GetActiveIndex;
  repeat
    if frmMain.FindAndReplace(edtFindPrepr.Text, '', IndexPreprMemo(i), True, False, False)<>0 then //
    begin
      if pgcntrlPrepr.ActivePageIndex<>i then pgcntrlPrepr.ActivePageIndex:=i; //SetActiveMemo(i);
      tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
      Exit;
    end;
    with IndexPreprMemo(i) do SelStart := SelEnd;
    Dec(i);
    if i>=0 then
    begin
      with IndexPreprMemo(i) do
      begin
        SelStart := Length(Text)-1;
        SelEnd := SelStart;
      end;
    end;
  until i<0;

  MessageBeep(MB_OK);
  pgcntrlPrepr.ActivePageIndex := pgcntrlPrepr.PageCount-1; // SetActiveMemo(pnlMain.ControlCount-1);
  with ActivePreprMemo do
  begin
    SelStart := Length(Text)-1;
    SelEnd := SelStart;
  end;

  {
  if MessageBox(Application.Handle,
           PChar(' .    ?'),
           PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
  begin //     (  )
    pgcntrlPrepr.ActivePageIndex := pgcntrlPrepr.PageCount-1; // SetActiveMemo(pnlMain.ControlCount-1);
    with ActivePreprMemo do
    begin
      SelStart := Length(Text)-1;
      SelEnd := SelStart;
    end;
  end;
  }
  ActivePreprMemo.SetFocus;
  tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
end;

{
procedure TfrmPreprShow.tlbtnFindUpPreprClick(Sender: TObject);
var
  ATempStr, ASStr: string;
  APos, i: Integer;
  ATempMemo: TSynMemo;
begin //     
  if edtFindPrepr.Text='' then Exit; //  ,    
  ANewPage := False;
  i := pgcntrlPrepr.ActivePageIndex;
  repeat
    ATempMemo := (pgcntrlPrepr.Pages[i].Controls[0] as TSynMemo);
    with ATempMemo do
    begin
      ASStr := AnsiLowerCase(edtFindPrepr.Text);
      ATempStr := AnsiLowerCase(Text);
      if ANewPage then APos := PosTr(ASStr, ATempStr, Length(ATempStr))
      else APos := PosTr(ASStr, ATempStr, SelStart);
      if APos>=0 then
      begin
        if ANewPage then // ,    
        begin
          pgcntrlPrepr.ActivePage := pgcntrlPrepr.Pages[i];
          ANewPage := False; //     
        end;
        SetFocus;
        SelStart := APos;
        SelEnd := APos + Length(edtFindPrepr.Text);
        Exit;
      end
      else
      begin
        i := i - 1;
        ANewPage := True;
      end;
    end;
  until i<0;
  if MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
        PChar(' .   ?'),
        PChar(' '), MB_ICONWARNING + MB_YESNO) = IDYES then
  begin //     (  )
    i := pgcntrlPrepr.PageCount-1;
    with pgcntrlPrepr do ActivePage := Pages[i];
    ATempMemo := (pgcntrlPrepr.Pages[i].Controls[0] as TSynMemo);
    with ATempMemo do
    begin
      SelStart := Length(Text);
      SelEnd := Length(Text);
      SetFocus;
    end;
  end;
end;
}

procedure TfrmPreprShow.edtFindPreprDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin //     edtFindPrepr
  edtFindPrepr.Text := (Source as TSynMemo).SelText;
  frmMain.AddTextInCombo(edtFindPrepr);
end;

procedure TfrmPreprShow.edtFindPreprDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin //     edtFindPrepr
  Accept := Source is TSynMemo;
end;

procedure TfrmPreprShow.tlbtnAllHeadersPreprClick(Sender: TObject);
var
  HMemo: TSynMemo;
  FullHName, HName: string;
begin //    ""
  if (PrgOpt.HPath<>'') and DirectoryExists(PrgOpt.HPath) then
    opndlgOpenH.InitialDir := PrgOpt.HPath;
  if opndlgOpenH.Execute then
  begin
    FullHName := opndlgOpenH.FileName;
    HName := ExtractFileName(FullHName);
    try
      if FileExists(FullHName) and not(GetHeaderOpen(HName)) then
      begin
        HMemo := AddNewPageForPrepr(AnsiLowerCase(HName));
        stsbrPrepr.Panels[0].Text := FullHName;
        HMemo.Lines.LoadFromFile(FullHName);
        IncludeFind(HMemo);
        if TrimRight(AnsiLowerCase(ExtractFileDir(FullHName)))<>TrimRight(AnsiLowerCase(PrgOpt.HPath)) then
          HMemo.Hint := FullHName;
        EnabledControl;
      end;
    except
      ShowMessage(' : h-     "tlbtnAllHeadersPreprClick"');
    end;
  end;
end;

procedure TfrmPreprShow.edtFindPreprKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then // Esc
    ModalResult := mrCancel;
end;

procedure TfrmPreprShow.edtFindPreprEnter(Sender: TObject);
begin
  //if pgcntrlPrepr.PageCount=0 then //tlbrPrepr.Enabled := False;
  //ModalResult := mrCancel;
end;

procedure TfrmPreprShow.TlBtnRereadHClick(Sender: TObject);
var
  HMemo: TSynMemo;
  FullHName: string;
begin //  ""
  HMemo := pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo;
  with HMemo do
  begin
    if Hint<>'' then FullHName := Hint
    else  FullHName := PrgOpt.HPath + '\' + pgcntrlPrepr.ActivePage.Caption;
    if FileExists(FullHName) then
      begin
        stsbrPrepr.Panels[0].Text := FullHName;
        Lines.LoadFromFile(FullHName);
        IncludeFind(HMemo);
      end;
   end;
end;

procedure TfrmPreprShow.TlBtnEditHClick(Sender: TObject);
var
  HMemo: TSynMemo;
  FullHName: string;
begin //  "  "
  if FileExists(PrgOpt.HEditor) then
    with HMemo do
    begin
      HMemo := pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo;
      if Hint<>'' then FullHName := Hint
      else  FullHName := PrgOpt.HPath + '\' + pgcntrlPrepr.ActivePage.Caption;
      ShellExecute(Application.Handle,
                   'open',
                   PChar(ExtractFileName(PrgOpt.HEditor)),
                   PChar(FullHName),
                   PChar(ExtractFilePath(PrgOpt.HEditor)),
                   SW_SHOWNORMAL);
    end
  else TlBtnEditH.Enabled := False;
end;

procedure TfrmPreprShow.pgcntrlPreprMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //        Ctrl   
  if (Button = mbLeft) and (ssCtrl in Shift) and mnuPopPage.AutoPopup then  //(HiWord(GetKeyState(VK_CONTROL))<>0)
    mnuCloseActiveClick(Sender);
    {with pgcntrlPrepr do
    begin
      ActivePage.Free;
      if PageCount=0 then
      begin
        edtFindPrepr.Enabled := False;
        tlbtnFindDownPrepr.Enabled := False;
        tlbtnFindUpPrepr.Enabled := False;
        TlBtnRereadH.Enabled := False;
        TlBtnEditH.Enabled := False;
      end;
    end;  }
end;

procedure TfrmPreprShow.mnuPopPreprPopup(Sender: TObject);
begin
  with (pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo) do
    itmCopyOnlyL.Enabled := SelText<>''; // 
end;

procedure TfrmPreprShow.mnuCloseActiveClick(Sender: TObject);
begin //   
  pgcntrlPrepr.ActivePage.Free;
  EnabledControl;
end;

procedure TfrmPreprShow.EnabledControl;
begin //         
  with pgcntrlPrepr do
  begin
    tlbtnOpenInclude.Enabled := (PageCount<>0) and (ActivePreprMemo.Tag<>0);
    tlbtnOpenAll.Enabled := (PageCount<>0);
    TlBtnRereadH.Enabled := (PageCount<>0);
    TlBtnEditH.Enabled := (PageCount<>0) and FileExists(PrgOpt.HEditor);
    edtFindPrepr.Enabled := (PageCount<>0);
    tlbtnFindDownPrepr.Enabled := (PageCount<>0);
    tlbtnFindUpPrepr.Enabled := (PageCount<>0);
  end;
end;

procedure TfrmPreprShow.FormActivate(Sender: TObject);
begin
  tmrAntiCombo.Enabled := True; //     TComboBox
end;

procedure TfrmPreprShow.tmrAntiComboTimer(Sender: TObject);
begin
  tmrAntiCombo.Enabled := False;
  edtFindPrepr.Refresh;
  //edtFindPrepr.Repaint;
  //edtFindPrepr.SetFocus;
  //edtFindPrepr.SelectAll;
  //edtFindPrepr.s
  //LockWindowUpdate(edtFindPrepr.Handle);
  //edtFindPrepr.SelStart := 0;
  //edtFindPrepr.SelLength := 0; //Length(edtFindPrepr.Text) - 1;

  //edtFindPrepr.SetFocus;


  //LockWindowUpdate(0);
  //edtFindPrepr.DroppedDown := True;
  //edtFindPrepr.Visible := False;
  //edtFindPrepr.Visible := True;

  //edtFindPrepr.SetFocus;
  //edtFindPrepr.SelectAll;
  //edtFindPrepr.SelStart := 0;
  //edtFindPrepr.Refresh;
  //edtFindPrepr.Repaint;
end;

procedure TfrmPreprShow.pgcntrlPreprChange(Sender: TObject);
begin
  tlbtnOpenInclude.Enabled := ActivePreprMemo.Tag<>0;
end;

procedure TfrmPreprShow.tlbtnOpenAllClick(Sender: TObject);
var i: Integer;
begin //   ,    
  if pgcntrlPrepr.PageCount>0 then
  begin
    i := 0;
    while i<pgcntrlPrepr.PageCount do
    begin
      HFileLoadShow(pgcntrlPrepr.Pages[i].Controls[0] as TSynMemo);
      Inc(i);
    end;
  end;
end;

procedure TfrmPreprShow.tlbtnOpenIncludeClick(Sender: TObject);
begin //   ,   
  if pgcntrlPrepr.PageCount>0 then HFileLoadShow(pgcntrlPrepr.ActivePage.Controls[0] as TSynMemo);
end;

procedure TfrmPreprShow.mnuCloseAllExtActiveClick(Sender: TObject);
begin //   ,  
  with pgcntrlPrepr do
  begin
    ActivePage.PageIndex := 0;
    while PageCount>1 do Pages[PageCount-1].Free;
  end;
end;

end.
